---------------------------------------------------------------------------------------------------
--
-- Title       : ula4bits
-- Design      : ula4bits
-- Author      : Fernando
-- Company     : Moraes
--
---------------------------------------------------------------------------------------------------
--
-- File        : ula4bits.vhd
-- Generated   : Mon Mar 27 18:33:18 2006
-- From        : interface description file
-- By          : Itf2Vhdl ver. 1.20
--
---------------------------------------------------------------------------------------------------
--
-- Description : 
--
---------------------------------------------------------------------------------------------------

--{{ Section below this comment is automatically maintained
--   and may be overwritten
--{entity {ula4bits} architecture {ula4bits}}
library IEEE;
use IEEE.STD_LOGIC_1164.all; 
package ULA is
	type op is (Soma, SubBdeA, IncB, DecA, inv_B, op_nand, 
	            op_or, op_nxor);
end ULA;

	
library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_unsigned.all;
use work.ULA.all;

entity ula4bits is
	 port(
		 operacao : in op;
		 ent_A : in STD_LOGIC_VECTOR(3 downto 0);
		 ent_B : in STD_LOGIC_VECTOR(3 downto 0);
		 N : out STD_LOGIC;
		 Z : out STD_LOGIC;
		 C : out STD_LOGIC;
		 V : out STD_LOGIC;
		 resultado : out STD_LOGIC_VECTOR(3 downto 0)
	     );
end ula4bits;

--}} End of automatically maintained section

architecture ula4bits of ula4bits is  
signal int_ent_A, int_ent_B, int_res: STD_LOGIC_VECTOR(4 downto 0);
signal add_V, sub_V : std_logic;
begin			
	
	int_ent_A <= '0' & ent_A;
	int_ent_B <= '0' & ent_B;
	resultado <= int_res(3 downto 0);
	
	with operacao select 
	int_res	  <= int_ent_A + int_ent_B 		when Soma,
				 int_ent_A - int_ent_B 		when SubBdeA,
				 int_ent_B + 1	   		when IncB,
				 int_ent_A - 1 	  	 	when DecA,
				 not int_ent_B 	   		when inv_B,
				 int_ent_A nand int_ent_B 	when op_nand,
				 int_ent_A or int_ent_B 	when op_or,
				 int_ent_A xnor int_ent_B 	when others; 
				 
	N <= int_res(3);
	Z <= '1' when int_res(3 downto 0) ="0000" else '0';
	C <= int_res(4);							
	
	add_V <= '1' when (((ent_A(3)=ent_B(3)) 
	and operacao=Soma and int_res(3)/=ent_A(3)) or 
	(ent_B="0111" and operacao=incB)) else '0';  

	sub_V <= '1' when (((ent_A(3)/=ent_B(3)) 
	and operacao=SubBdeA and int_res(3)/=ent_A(3)) or 
	(ent_A="1000" and operacao=decA)) else '0';  

	V <= '1' when add_V='1' or sub_V='1' else '0';
	
end ula4bits;
